#ifndef _CONVERT_H
#define _CONVERT_H

/**
 */
/*
 * (c) Copyright 2015 Hewlett-Packard Development Company, L.P
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1301, USA.
 */


#define WWN_LEN 8
#define MaxSerialNumberSize 30
struct hochtalu {
        unsigned int host;
        unsigned int channel;
        unsigned int target;
        unsigned int lun;
};

struct pfo_ID {
	unchar wwnn[WWN_LEN];
	unchar serial_num[MaxSerialNumberSize];
	unchar serial_num_len;
	struct hochtalu hctl;
	unsigned int f_flags;
	int pfo_minor;
};

int pfo_open_drive(struct pfo_ID *pfo_id);
int pfo_open_changer(struct pfo_ID *pfo_id);
int pfo_close_drive(struct pfo_ID *pfo_id);
int pfo_close_changer(struct pfo_ID *pfo_id);
int pfo_tape_pass_thru(struct pfo_ID *pfo_id, unchar* cdb,
	unchar cmd_length, unchar* buffer, uint *buffer_length,
	uint data_direction, uint timeout, unchar* sense,
	unchar *sense_length, unchar *sense_avail, int *resid, int *result);
int pfo_changer_pass_thru(struct pfo_ID *pfo_id, unchar* cdb,
	unchar cmd_length, unchar* buffer, uint *buffer_length,
	uint data_direction, uint timeout, unchar* sense,
	unchar *sense_length, unchar *sense_avail, int *resid, int *result);
#define MAX_32 32
int pfo_failover_device(unchar pfoID[MAX_32], unchar enabled);
int join_register_interface(struct class_interface *intf);
void join_unregister_interface(struct class_interface *intf);

#endif
